using System.Collections.Generic;

namespace ZenithInfo.Models
{
    public static class Enums
    {
        public enum ModuleSizes
        {
            All,
            Small,
            Medium,
            Large,
            Capital,
            MiningSmall,
            MiningMedium,
            MiningCapital,
            SmallBase,
            MediumBase,
            LargeBase,
        }

        public enum ModuleTypes
        {
            Passive,
            Toggle,
            Active,
            AoE,
        }

        public enum Rarities
        {
            Common,
            Rare,
            Scare,
            Unique,
        }

        public enum DamageTypes
        {
            Shield,
            Hull,
        }

        public enum SpinalTypes
        {
            Hitscan,
            Multishot,
        }

        public enum TurretTypes
        {
            Artillery,
            Autocannon,
            BeamLaser,
            Blaster,
            Railgun,
            PulseLaser,
        }

        public static Dictionary<TurretTypes, DamageTypes> TurretDamageTypes { get; } =
            new Dictionary<TurretTypes, DamageTypes>
            {
                { TurretTypes.Artillery, DamageTypes.Hull },
                { TurretTypes.Autocannon, DamageTypes.Hull },
                { TurretTypes.BeamLaser, DamageTypes.Shield },
                { TurretTypes.Blaster, DamageTypes.Shield },
                { TurretTypes.Railgun, DamageTypes.Hull },
                { TurretTypes.PulseLaser, DamageTypes.Shield },
            };

        public enum ModuleEffectTypes
        {
            Duration,
            Persistent,
            AoE,
        }

        public enum IsBuffed
        {
            True,
            False,
            Self,
        }
    }
}
